# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.
#
# Copyright (c) 2016-2018 Intra2net AG <info@intra2net.com>

"""
Create intraclients.
"""

from . import build_cnfvar

default_intraclient_name = "sample client"
default_intraclient_instance = 1
default_cnfvars = {
    "INTRACLIENT_COMMENT": default_intraclient_name + " comment",
    "INTRACLIENT_DNS_RELAYING_ALLOWED": "1",
    "INTRACLIENT_EMAIL_RELAYING_ALLOWED": "1",
    "INTRACLIENT_FIREWALL_RULESET_REF": "5",
    "INTRACLIENT_IP": None,
    "INTRACLIENT_MAC": None,
    "INTRACLIENT_PROXY_PROFILE_REF": "-1",
}


class BuildIntraclient(build_cnfvar.BuildCnfVar):

    def __init__(self,
                 data=default_intraclient_name,
                 instance=default_intraclient_instance,
                 line_no=1,
                 ip="192.168.0.42",
                 mac=None,
                 alias=None):
        build_cnfvar.BuildCnfVar.__init__(self,
                                          "INTRACLIENT",
                                          instance,
                                          data, line_no)
        self.add_defaults(default_cnfvars)

        self.update_cnf("INTRACLIENT_IP", 0, ip)
        self.update_cnf("INTRACLIENT_MAC", 0, mac or "")

        if alias is not None:
            self.update_cnf("INTRACLIENT_ALIAS", 0, alias)
